/*
 
 Les 6 VO Arduino Lessenserie Fontys Hogeschool ICT
   THEORIE: (omrekenen van analoge waarde naar temperatuur.)???
   
   Lees een temperatuursensor uit en projecteer
   de temperatuur op een LCD-scherm. Gebruik de potmeter
   om de helderheid van het display aan te kunnen passen.
   
 Benodigde onderdelen:
 1 x TMP36 temperature sensor 
 1 x 220 ohm weerstand
 1 x 16x2 LCD Scherm 
 1 x Potentiometer

 */
  
// laad de LCD-library
#include <LiquidCrystal.h>
// open de library met de nummers van de LCD communicatie PIN's
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);
// definieer de analoge PIN van de sensor
const int sensorPin = A0;

void setup(){
  // open a serial connection to display values
  Serial.begin(9600);
  // definieer het aantal kolommen en rijen van de LCD
  lcd.begin(16,2);
  // stuur een eenmalige boodschap naar de LCD
  lcd.print("Start_T = ");
  // Wacht 0,1 seconde
  delay(100);
}

void loop(){
  // lees de waarde van PIN A0 en sla die op in sensorVal
  // Het analogRead() commando converteert het input voltage, 0 to 5 volt
  // naar een digitale waarde tussen 0 and 1023. Dit gebeurt door een 
  // analog-to-digital converter of ADC die op de Arduino zelf zit.
  int sensorVal = analogRead(sensorPin);

  // converteer de waarde naar voltage
  float voltage = (sensorVal/1024.0) * 5.0;

  // converteer het voltage naar temperatuur in graden celsius
  // de sensor verandert per graad met 10 mV
  // volgens het datasheet is eer een 500 mV "offset"=startwaarde
  // dus Temperatuur=((voltage - 500mV) x 100)
  float temperature = (voltage - .5) * 100;

  // print iedere kwart seconde de actuele temperatuur op de LCD
  // de eerste keer is het op regel 1 de start temperatuur, 
  // daarna op regele twee iedere kwart seconde de actuele temperatuur 
  lcd.print(temperature);
  // verplaats de cursor naar de tweede regel
  lcd.setCursor(0,1);
  lcd.print("Sensor_T= ");
  delay(250);  
}
  
  

